bzoj1044题解

【题意分析】

  本题等价于如下描述:

  有一个长度为n的正整数序列,要求将其分解成m+1个子串,使最大子串和最小。求这个最大子串和及对应的分解方案数。

【解题思路】

  第一问二分+贪心即可。容易证明对于确定的最大子串和,分解子串使子串个数最小是一个具有最优子结构的问题。复杂度O(nlog2Σli)。

  第二问DP即可。先预处理前缀和Si=∑lj(j∈[1,i])。

  然后考虑状态:f[i][j]表示前i个元素分解成j个子串的合法方案数。

  易得转移方程:f[i][j]=Σf[k][j-1](k∈[j-1,i)且Si-Sk≤ans)

  但直接DP会TLE(时间复杂度O(mn2))+MLE(空间复杂度O(mn)),于是考虑优化:

•空间复杂度:因为DP向量f[][j]只跟f[][j-1]有关,可以用滚动数组优化,空间复杂度O(n);

•时间复杂度:固定j时,随着i的递增,可行的最小k是单调不减的,所以可以用单调队列优化,时间复杂度O(mn);

  最后答案即为∑f[n][j](j∈[1,m+1])。总复杂度O(n(m+log2Σli))。

【参考程序】

 1 #include <bits/stdc++.h>
 2 #define range(i,c,o) for(register int i=(c);i<(o);++i)
 3 #define dange(i,c,o) for(register int i=(c);i>(o);--i)
 4
 5 #define __debug
 6 #ifdef __debug
 7     #define Function(type) type
 8     #define Procedure      void
 9 #else
10     #define Function(type) __attribute__((optimize("-O2"))) inline type
11     #define Procedure      __attribute__((optimize("-O2"))) inline void
12 #endif
13
14 using namespace std;
15
16 static const int AwD=10007;
17 Function(int&) inc(int&x,const int&y)
18 {
19     return (x+=y)>=AwD?x-=AwD:x;
20 }
21 Function(int&) dec(int&x,const int&y)
22 {
23     return (x-=y)<  0 ?x+=AwD:x;
24 }
25
26 static int n,m;
27 int L[50005],S[50005]={0},las[50005],f[50005];
28
29 int main()
30 {
31     scanf("%d%d",&n,&m); int l=0,r=0;
32     range(i,1,n+1) scanf("%d",L+i),l=max(l,L[i]),r+=L[i];
33     while(l<r)
34     {
35         int mid=l+r>>1,cnt=0,sum=0;
36         range(i,1,n+1) if((sum+=L[i])>mid) sum=L[i],++cnt;
37         cnt>m?l=mid+1:r=mid;
38     }
39     printf("%d ",r);
40     range(i,1,n+1) if((S[i]=S[i-1]+L[i])<=r) las[i]=1;
41     int ans=las[n];
42     range(i,2,m+2)
43     {
44         int h=1,sum=0; range(j,1,i) sum+=las[j],f[j]=0;
45         range(j,i,n+1)
46         {
47             for(;S[j]-S[h]>r;dec(sum,las[h++]));
48             f[j]=sum,inc(sum,las[j]);
49         }
50         memcpy(las,f,sizeof las),inc(ans,f[n]);
51     }
52     return printf("%d\n",ans),0;
53 }

时间: 2024-12-11 00:58:21

bzoj1044题解的相关文章

HAOI2008题解

又来写题解辣-然而并不太清楚题目排列情况...不管辣先写起来- T1:[bzoj1041] 题目链接:http://www.lydsy.com/JudgeOnline/problem.php?id=1041 一个赤果果的数学题--- 首先坐标轴上一定有四个, 最大公约数搞一下然后判断一下就可以啦,细节全部都在代码- 代码如下: 1 var i,j,ans,d:longint; 2 t,r,m:int64; 3 function flag(x,y:longint):longint; 4 var t

BZOJ1044: [HAOI2008]木棍分割

1044: [HAOI2008]木棍分割 Time Limit: 10 Sec  Memory Limit: 162 MBSubmit: 1580  Solved: 567[Submit][Status] Description 有n根木棍, 第i根木棍的长度为Li,n根木棍依次连结了一起, 总共有n-1个连接处. 现在允许你最多砍断m个连接处, 砍完后n根木棍被分成了很多段,要求满足总长度最大的一段长度最小, 并且输出有多少种砍的方法使得总长度最大的一段长度最小. 并将结果mod 10007.

洛谷 P1079 Vigen&#232;re 密码 题解

此文为博主原创题解,转载时请通知博主,并把原文链接放在正文醒目位置. 题目链接:https://www.luogu.org/problem/show?pid=1079 题目描述 16 世纪法国外交家 Blaise de Vigenère 设计了一种多表密码加密算法――Vigenère 密 码.Vigenère 密码的加密解密算法简单易用,且破译难度比较高,曾在美国南北战争中为 南军所广泛使用. 在密码学中,我们称需要加密的信息为明文,用 M 表示:称加密后的信息为密文,用 C 表示:而密钥是一种

8.8联考题解

今天的T1让我怀疑我是不是在做奥赛题--这考的是什么知识点啊这个,会不会用绝对值函数? Evensgn 的债务 时间限制: 1 Sec  内存限制: 128 MB 题目描述 Evensgn 有一群好朋友,他们经常互相借钱.假如说有三个好朋友A,B,C.A 欠 B 20 元,B 欠 C 20 元,总债务规模为 20+20=40 元.Evensgn 是个追求简约的人,他觉得这样的债务太繁杂了.他认为,上面的债务可以完全等价为 A 欠C20 元,B 既不欠别人,别人也不欠他.这样总债务规模就压缩到了 

POJ 2533 - Longest Ordered Subsequence(最长上升子序列) 题解

此文为博主原创题解,转载时请通知博主,并把原文链接放在正文醒目位置. 题目链接:http://poj.org/problem?id=2533 Description A numeric sequence of ai is ordered if a1 < a2 < ... < aN. Let the subsequence of the given numeric sequence (a1, a2, ..., aN) be any sequence (ai1, ai2, ..., aiK)

(leetcode题解)Pascal&#39;s Triangle

Pascal's Triangle  Given numRows, generate the first numRows of Pascal's triangle. For example, given numRows = 5,Return [ [1], [1,1], [1,2,1], [1,3,3,1], [1,4,6,4,1] ] 题意实现一个杨辉三角. 这道题只要注意了边界条件应该很好实现出来,C++实现如下 vector<vector<int>> generate(int

2017ZZUACM省赛选拔试题部分题解----谨以纪念我这卡线滚粗的美好经历

写在前面: 其实心里有些小小的不爽又有点小小的舒畅,为啥捏?不爽当然是因为没被选拔上啦,舒畅捏则是因为没被选拔上反而让自己警醒,学长也提点很多很多."沉下去,然后一战成名"学长如是对我说,我很开心.其实这完全算不算是题解,只是我个人的一些小想法而已.而且到现在还有一题不会...让自己长点记性吧. 题目 A :聪明的田鼠 Time Limit: 1 Sec Memory Limit: 128 MB Description 田鼠MIUMIU来到了一片农田,农田可以看成是一个M*N个方格的矩

LeetCode-001题解

此题目摘自LeetCode001 Given an array of integers, find two numbers such that they add up to a specific target number. The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2.

leetcode题解: Next Permutation

最近还一直在刷leetcode,当然,更多时候只是将题解写在自己的电脑上,没有分享出来.偶尔想起来的时候,就写出来. public class Solution { public void nextPermutation(int[] nums) { if(nums==null||nums.length<=1) return; nextPermutationHelp( nums,0,nums.length-1); } public void nextPermutationHelp(int []nu